unit Runtime_Kane;

interface
procedure Move(const src; var dest; n : Cardinal);
procedure XOR_SIMD(const src1,src2 : pointer; dest : pointer; size : Cardinal);
procedure FillChar(var X; Count : Cardinal; Value : ShortInt);
//procedure InitWaveletTransform(Width : Cardinal; Height : Cardinal);cdecl;external 'Runtime_Kane.dll';
//procedure WaveletTransform(src,dest : PByte);cdecl;external 'Runtime_Kane.dll';
//procedure WaveletInverse(src,dest : PByte);cdecl;external 'Runtime_Kane.dll';
var
  //g߃tO
  MMX_Detected,
  AMD_3DNow_Detected,
  AMD_Enhanced3DNow_Detected,
  SSE_Detected,
  SSE2_Detected,
  SSE3_Detected,
  SSSE3_Detected,
  SSE41_Detected,
  SSE42_Detected,
  SSE4a_Detected,
  SSE5_Detected
   : Boolean;

implementation

procedure CPUCheck;
const
 MMX_FLAG = $00800000;
 SSE_FLAG = $02000000;
 SSE2_FLAG = $04000000;
 SSE3_FLAG = $00000001;
 SSSE3_FLAG = $0000400;
 SSE41_FLAG = $00100000;
 SSE42_FLAG = $00200000;
 SSE4A_FLAG = $00000080;
 SSE5_FLAG = $00001000;

 AMD_3DNOW_FLAG = $80000000;
 AMD_ENHANCED_3DNOW_FLAG = $40000000;

var
cpuflag, cpuflag2, cpuflag3, cpuflag4 : Cardinal;

begin
cpuflag := 0;
cpuflag2 := 0;
cpuflag3 := 0;
cpuflag4 := 0;
  asm
  push      eax
  push      ebx
  push      ecx
  push      edx

  mov       eax,      1
  cpuid
  mov       cpuflag,  edx
  mov       cpuflag2, ecx

  mov       eax,      $80000000
  cpuid
  cmp       eax,      $80000001
  jb        @Last

  mov       eax,      $80000001
  cpuid
  mov       cpuflag3, edx
  mov       cpuflag4, ecx

  @Last:
  pop       edx
  pop       ecx
  pop       ebx
  pop       eax
  end;

MMX_Detected := (cpuflag and MMX_FLAG) = MMX_FLAG;
SSE_Detected := (cpuflag and SSE_FLAG) = SSE_FLAG;
SSE2_Detected := (cpuflag and SSE2_FLAG) = SSE2_FLAG;
SSE3_Detected := (cpuflag2 and SSE3_FLAG) = SSE3_FLAG;
SSSE3_Detected := (cpuflag2 and SSSE3_FLAG) = SSSE3_FLAG;
SSE41_Detected := (cpuflag2 and SSE41_FLAG) = SSE41_FLAG;
SSE42_Detected := (cpuflag2 and SSE42_FLAG) = SSE42_FLAG;
AMD_3DNow_Detected := (cpuflag3 and AMD_3DNOW_FLAG) = AMD_3DNOW_FLAG;
AMD_Enhanced3DNow_Detected := (cpuflag3 and AMD_ENHANCED_3DNOW_FLAG) = AMD_ENHANCED_3DNOW_FLAG;
SSE4a_Detected := (cpuflag4 and SSE4A_FLAG) = SSE4A_FLAG;
SSE5_Detected := (cpuflag4 and SSE5_FLAG) = SSE5_FLAG;

end;

procedure XOR_SIMD(const src1,src2 : pointer; dest : pointer; size : Cardinal);
var
size2 : Cardinal;
begin
size2 := size mod 32;
size := size div 32;
  if SSE_Detected then
  begin
    asm
    push eax
    push ecx
    push esi
    push edi
    push ebx

    mov ecx, size
    mov esi, src1
    mov ebx, src2
    mov edi, dest
    mov eax, 32

    cmp ecx, 0;
    je @Loop32End

    @Loop32:
    prefetchnta [esi+1024]
    movq mm0, [esi]
    movq mm1, [esi+8]
    movq mm2, [esi+16]
    movq mm3, [esi+24]
    prefetchnta [ebx+1024]
    pxor mm0, [ebx]
    pxor mm1, [ebx+8]
    pxor mm2, [ebx+16]
    pxor mm3, [ebx+24]

    movntq [edi], mm0
    movntq [edi+8], mm1
    movntq [edi+16], mm2
    movntq [edi+24], mm3

    add esi, eax
    add edi, eax
    add ebx, eax

    dec ecx
    jnz @Loop32

    emms

    @Loop32End:
    mov ecx, size2
    cmp ecx, 0
    je @LoopEnd

    @Loop:
    mov eax, [esi]
    xor eax, [ebx]
    movnti [edi], eax

    inc esi
    inc esi
    inc esi
    inc esi

    inc ebx
    inc ebx
    inc ebx
    inc ebx

    inc edi
    inc edi
    inc edi
    inc edi

    dec ecx
    jnz @Loop

    @LoopEnd:
    pop ebx
    pop edi
    pop esi
    pop ecx
    pop eax
    end;
  end
  else begin
    asm
    push eax
    push ecx
    push esi
    push edi
    push ebx

    mov ecx, size
    mov esi, src1
    mov ebx, src2
    mov edi, dest
    mov eax, 32

    cmp ecx, 0;
    je @Loop32End

    @Loop32:
    movq mm0, [esi]
    movq mm1, [esi+8]
    movq mm2, [esi+16]
    movq mm3, [esi+24]
    pxor mm0, [ebx]
    pxor mm1, [ebx+8]
    pxor mm2, [ebx+16]
    pxor mm3, [ebx+24]

    movq [edi], mm0
    movq [edi+8], mm1
    movq [edi+16], mm2
    movq [edi+24], mm3

    add esi, eax
    add edi, eax
    add ebx, eax

    dec ecx
    jnz @Loop32

    emms

    @Loop32End:
    mov ecx, size2
    cmp ecx, 0
    je @LoopEnd

    @Loop:
    mov eax, [esi]
    xor eax, [ebx]
    mov [edi], eax

    inc esi
    inc esi
    inc esi
    inc esi

    inc ebx
    inc ebx
    inc ebx
    inc ebx

    inc edi
    inc edi
    inc edi
    inc edi

    dec ecx
    jnz @Loop

    @LoopEnd:
    pop ebx
    pop edi
    pop esi
    pop ecx
    pop eax
    end;
  end;
end;


//TCYقǑ
//PLbVɎ܂TCYƁAoXxɋ߂xo܂
//̈悪dȂĂꍇɂΉB
procedure Move(const src; var dest; n : Cardinal);
var
  n2, n3, pSrc, pDest: Cardinal;
begin
if n <= 0 then exit;

pSrc := Cardinal(@src);
pDest := Cardinal(@dest);

if pSrc = pDest then exit;

  asm
  push      esi
  push      edi
  push      eax
  push      ebx
  push      ecx
  push      edx

  mov       esi,      pSrc
  mov       edi,      pDest

  @CheckAlignStart:
    mov       ebx,      esi
    and       ebx,      $F //mod 16

    mov       eax,      edi
    and       eax,      $F
    add       ebx,      eax
  @CheckAlignEnd:


  @CheckAddressStart:
    mov       eax,      n
    mov       n3,       eax
    mov       ecx,      eax
    mov       edx,      eax

    and       ecx,      $1F  //mod 32
    mov       n2,       ecx
    shr       edx,      5   //div 32
    mov       n,        edx

    cmp       esi,      edi
    ja        @NormalCopy
    mov       ecx,      esi
    add       ecx,      eax
    cmp       edi,      ecx
    jae       @NormalCopy
    jmp       @ReverseCopy
  @CheckAddressEnd:


  //ʏRs[
  @NormalCopy:
    cmp       SSE_Detected, 0
    je        @NormalCopyMMX
    cmp       n3,       2048
    jb        @NormalCopyMMX
    cmp       ebx,      0
    ja        @NormalCopySSE

    //16byteACĂ
    @NormalCopySSEAligned:
      mov       ecx,      n
      mov       eax,      32

      cmp       ecx,      0;
      je        @NormalCopySSEAlignedLoop32End

      @NormalCopySSEAlignedLoop32:
      prefetchnta [esi+1024]
      movaps    xmm0,     [esi]
      movaps    xmm1,     [esi+16]
      movntps   [edi],    xmm0
      movntps   [edi+16], xmm1

      add       esi,      eax
      add       edi,      eax

      dec       ecx
      jnz       @NormalCopySSEAlignedLoop32


      @NormalCopySSEAlignedLoop32End:
      mov       ecx,      n2
      cmp       ecx,      0
      je        @NormalCopySSEAlignedLoopEnd

      @NormalCopySSEAlignedLoop:
      mov       al,       [esi]
      mov       [edi],    al

      inc       esi
      inc       edi
      dec       ecx
      jnz       @NormalCopySSEAlignedLoop
      @NormalCopySSEAlignedLoopEnd:
      jmp       @Exit
    @NormalCopySSEAlignedEnd:


    @NormalCopySSE:
      mov       ecx,      n
      mov       eax,      32

      cmp       ecx,      0;
      je        @NormalCopySSELoop32End

      @NormalCopySSELoop32:
      prefetchnta [esi+1024]
      movq      mm0,      [esi]
      movq      mm1,      [esi+8]
      movq      mm2,      [esi+16]
      movq      mm3,      [esi+24]
      movntq    [edi],    mm0
      movntq    [edi+8],  mm1
      movntq    [edi+16], mm2
      movntq    [edi+24], mm3

      add       esi,      eax
      add       edi,      eax

      dec       ecx
      jnz       @NormalCopySSELoop32

      emms

      @NormalCopySSELoop32End:
      mov       ecx,      n2
      cmp       ecx,      0
      je        @NormalCopySSELoopEnd

      @NormalCopySSELoop:
      mov       al,       [esi]
      mov       [edi],    al

      inc       esi
      inc       edi
      dec       ecx
      jnz       @NormalCopySSELoop

      @NormalCopySSELoopEnd:
      jmp       @Exit

    @NormalCopySSEEnd:


    @NormalCopyMMX:
      mov       ecx,      n
      mov       eax,      32

      cmp       ecx,      0;
      je @NormalCopyMMXLoop32End

      @NormalCopyMMXLoop32:
      movq      mm0,      [esi]
      movq      mm1,      [esi+8]
      movq      mm2,      [esi+16]
      movq      mm3,      [esi+24]
      movq      [edi],    mm0
      movq      [edi+8],  mm1
      movq      [edi+16], mm2
      movq      [edi+24], mm3

      add       esi,      eax
      add       edi,      eax

      dec       ecx
      jnz @NormalCopyMMXLoop32

      emms

      @NormalCopyMMXLoop32End:
      mov       ecx,      n2
      cmp       ecx,      0
      je @NormalCopyMMXLoopEnd

      @NormalCopyMMXLoop:
      mov       al,       [esi]
      mov       [edi],    al

      inc       esi
      inc       edi
      dec       ecx
      jnz       @NormalCopyMMXLoop

      @NormalCopyMMXLoopEnd:
      jmp       @Exit
    @NormalCopyMMXEnd:

  @NormalCopyEnd:


  //̈悪dȂĂꍇ
  @ReverseCopy:
    cmp       SSE_Detected, 0
    je        @ReverseCopyMMX

    @ReverseCopySSE:
      mov       ecx,      n
      mov       eax,      32
      add       esi,      n3
      add       edi,      n3
      sub       esi,      eax
      sub       edi,      eax

      cmp       ecx,      0;
      je        @ReverseCopySSELoop32End


      @ReverseCopySSELoop32:
      movq      mm3,      [esi-24]
      movq      mm2,      [esi-16]
      movq      mm1,      [esi-8]
      movq      mm0,      [esi]
      movntq    [edi-24], mm3
      movntq    [edi-16], mm2
      movntq    [edi-8],  mm1
      movntq    [edi],    mm0

      sub       esi,      eax
      sub       edi,      eax

      dec       ecx
      jnz       @ReverseCopySSELoop32

      emms

      @ReverseCopySSELoop32End:
      mov       ecx,      n2
      cmp       ecx,      0
      je        @ReverseCopySSELoopEnd

      add       esi,      31
      add       edi,      31

      @ReverseCopySSELoop:
      mov       al,       [esi]
      mov       [edi],    al

      dec       esi
      dec       edi
      dec       ecx
      jnz       @ReverseCopySSELoop

      @ReverseCopySSELoopEnd:
      jmp       @Exit
    @ReverseCopySSEEnd:


    @ReverseCopyMMX:
      mov       ecx,      n
      mov       eax,      32
      add       esi,      n3
      add       edi,      n3
      sub       esi,      eax
      sub       edi,      eax

      cmp       ecx,      0;
      je        @ReverseCopyMMXLoop32End


      @ReverseCopyMMXLoop32:
      movq      mm3,      [esi-24]
      movq      mm2,      [esi-16]
      movq      mm1,      [esi-8]
      movq      mm0,      [esi]
      movq      [edi-24], mm3
      movq      [edi-16], mm2
      movq      [edi-8],  mm1
      movq      [edi],    mm0

      sub       esi,      eax
      sub       edi,      eax

      dec       ecx
      jnz       @ReverseCopyMMXLoop32

      emms

      @ReverseCopyMMXLoop32End:
      mov       ecx,      n2
      cmp       ecx,      0
      je        @ReverseCopyMMXLoopEnd

      add       esi,      31
      add       edi,      31

      @ReverseCopyMMXLoop:
      mov       al,       [esi]
      mov       [edi],    al

      dec       esi
      dec       edi
      dec       ecx
      jnz       @ReverseCopyMMXLoop

      @ReverseCopyMMXLoopEnd:
    @ReverseCopyMMXEnd:

  @ReverseCopyEnd:


  @Exit:

  pop       edx
  pop       ecx
  pop       ebx
  pop       eax
  pop       edi
  pop       esi
  end;


end;

procedure FillChar(var X; Count : Cardinal; Value : ShortInt);
var
  Count2, Count3 : Byte;
  Value32 : Cardinal;
  Value128 : packed Array[0..3] of Cardinal;

begin
  asm
  push      eax;
  mov       al,       Value;
  mov       ah,       al;
  shl       eax,      16;
  mov       al,       Value;
  mov       ah,       al;
  mov       Value32,  eax;
  pop       eax;
  end;

  if (Count < 512) or (not SSE_Detected) or (Cardinal(@X) mod 16 > 0) then
  begin
  Count2 := Count mod 32;
  Count := Count shr 5;
    asm
    push      edi;
    push      ecx;

    mov       edi,      X;
    cmp       Count,    0;
    je        @Loop32End;

    movd      mm0,      Value32;
    punpckldq mm0,      mm0;
    movq      mm1,      mm0;

    mov       ecx,      Count;

    @Loop32:
    movq      [edi],    mm0;
    movq      [edi+8],  mm1;
    movq      [edi+16], mm0;
    movq      [edi+24], mm1;

    add       edi,      32;
    dec       ecx;
    jnz       @Loop32;
    @Loop32End:

    mov       ch,       Count2;
    cmp       ch,       0;
    je        @LoopEnd;

    mov       cl,       Value;

    @Loop:
    mov       [edi],    cl;

    inc       edi;
    dec       ch;
    jnz       @Loop;
    @LoopEnd:

    emms;
    pop       ecx;
    pop       edi;
    end;
  end
  else begin

  Count3 := Cardinal(@X) mod 16;
  Count := Count - Count3;
  Count2 := Count mod 32;
  Count := Count shr 5;
  Value128[0] := Value32;
  Value128[1] := Value32;
  Value128[2] := Value32;
  Value128[3] := Value32;

    asm
    push      edi;
    push      ecx;

    mov       edi,      X;

    mov       cl,       Value;
    mov       ch,       Count3;
    cmp       ch,       0;
    je        @AlignEnd;

    @Align:
    mov       [edi],    cl;

    inc       edi;
    dec       ch;
    jnz       @Align;
    @AlignEnd:

    movups    xmm0,     Value128;
    movaps    xmm1,     xmm0;

    mov       ecx,      Count;

    @Loop32:
    movntps   [edi],    xmm0;
    movntps   [edi+16], xmm1;

    add       edi,      32;
    dec       ecx;
    jnz       @Loop32;
    @Loop32End:

    mov       ch,       Count2;
    cmp       ch,       0;
    je        @LoopEnd;

    mov       cl,       Value;

    @Loop:
    mov       [edi],    cl;

    inc       edi;
    dec       ch;
    jnz       @Loop;
    @LoopEnd:

    pop       ecx;
    pop       edi;
    end;

  end;

end;

initialization
CPUCheck;
SetMinimumBlockAlignment(mba16Byte);
end.
