unit GLDPNG;

// ******************************************************
// *                                                    *
// *  GLDPNG ver 3.4.3                                  *
// *                                   2002.03.17   *
// *                                                    *
// *   1998-2001 CopyRight Tarquin All Rights Reserved. *
// *                                                    *
// ******************************************************
//
// PNGtH[}bg̓ǂݏNXłB
//
// ȉ͎gp󋵂ɉĐݒ肵ĂB
// ȂAvWFNg̏`Ŏw肵ĂB
//
//  EGLD_READONLY    @EEE ǂݍ݂݂̂̃NX쐬
//  EGLD_SUPPORT_BIT15 EEE bitcount=15(3F)̓ǂݍ݃T|[g
//  EGLD_NOREVERSE_ALPHA   EEE At@`l0= 255=sɕύX܂

{$I taki.inc}

interface

uses
 Windows, Classes, SysUtils, Graphics,
 SFunc, GLDStream, GLDPNGStream, zlibpas;

const
 GLD_NONECOLOR = COLORREF(-1);  // wJ[Ȃ

 gplNone    = Z_NO_COMPRESSION;
 gplDefault = Z_DEFAULT_COMPRESSION;
 gplSpeed   = Z_BEST_SPEED;
 gplBest    = Z_BEST_COMPRESSION;

type
 TGLDPNGFilterType = (gpfJust,gpfNone,gpfSub,gpfUp,gpfAvg,gpfPaeth);
 TGLDPNGInterlaceType = (gptNone, gptAdam7);
 TGLDPNGUnitSpecifier = (gpuAspect,gpuMeter,gpuInch);

 TGLDPNGDECodeEvent = procedure (sender: TObject; pbuf: pbyte; buflen,lineno: integer; password: string) of object;
 TGLDPNGPasswordEvent = procedure (sender: TObject; var password: string) of object;

 TGLDPNG=class(TGraphic)
  private
   FTransFlag:      boolean;
   FIDATSize:       integer;              // IDAT̃TCY
   FCompressLevel:  integer;              // ZLIBkIvVݒ
   FFilterType:     TGLDPNGFilterType;    // k̎gptB^[
   FInterlaceType:  TGLDPNGInterlaceType; // C^[[X̎
   FGrayScale:      boolean;              // OCXP[ۑ
   FABmpIn,FABmp:   TGLDBmp;              // At@`lo͗prbg}bv
   FImgIn,FImg:     TGLDBmp;              // ێC[W

   FAlphaFlag:      boolean;              // At@`l̗L
   FOrgBitCount:    integer;              // ǂݍ񂾃f[^̖{̃rbg
   FBGColor:        COLORREF;             // wiF(p)
   FTransColor:     COLORREF;             // F(p)
   FText:           string;               // Rg(p)
   FGamma:          double;               // K}l
   FPassword:       string;               // pX[h
   FShiftRGB:       integer;              // evf̃Vtg
   FUnitSpecifier:  TGLDPNGUnitSpecifier; // 𑜓xP
   FWidthSpecific:  integer;              // 𑜓x
   FHeightSpecific: integer;              // c𑜓x
   FMacBinaryFlag:  boolean;              // }bNoCi`FbN̗L
   FNowTime:        boolean;              // ݎԂo
   FTime:           TPNGTime;             // w莞
   FChrm:           TPNGChromaticities;   // Fx
   FGIFExt:         TPNGGIFExtension;     // GIFf[^
   FRead16BitFlag:  boolean;              // 16BITsNZǂݍݗL

   FOnPassword:     TGLDPNGPasswordEvent; // pX[h̓Cxg
   FOnEncode:       TGLDPNGDECodeEvent;   // ÍCxg
   FOnDecode:       TGLDPNGDECodeEvent;   // Cxg

   procedure SetIDATSize(n: integer);
   procedure SetTransColor(cor: COLORREF);
   procedure SetTransFlag(obj: TGraphic);
   procedure SetABmp(obj: TGLDBmp);
   procedure SetImage(obj: TGLDBmp);
   procedure SetTime(tm: TPNGTime);
   function  GetTime: TPNGTime;
   procedure SetChrm(cm: TPNGChromaticities);
   function  GetChrm: TPNGChromaticities;
   procedure SetGIFExt(gif: TPNGGIFExtension);
   function  GetGIFEXt: TPNGGIFExtension;
  protected
   procedure ReadData(Stream: TStream); override;
   procedure WriteData(Stream: TStream); override;
   function  GetEmpty: boolean; override;
   function  GetPalette: HPALETTE; override;
   procedure SetPalette(hpal: HPALETTE); override;
   function  GetHeight: integer; override;
   function  GetWidth: integer; override;
   procedure AssignTo(dest: TPersistent); override;
   procedure Draw(ACanvas: TCanvas; const Rect: TRect); override;
   procedure SetWidth(n: integer); override;
   procedure SetHeight(n: integer); override;
   procedure SetTransparent(Value: Boolean); override;

   function  GetAlphaBitmap: TGLDBmp;
   function  GetImage: TGLDBmp;
  public
   constructor Create; override;
   destructor  Destroy; override;
   procedure Assign(source: TPersistent); override;
   procedure LoadFromStream(Stream: TStream); override;
   procedure SaveToStream(Stream: TStream); override;
   procedure LoadFromClipboardFormat(AFormat: Word;
                                     AData: THandle;
                                     APalette: HPALETTE); override;
   procedure SaveToClipboardFormat(var Format: Word;
                                   var Data: THandle;
                                   var APalette: HPALETTE); override;
   function  AlphaBitmapAssignTo(dest: TGraphic): boolean;
   procedure FreeAlphaBitmap;
   procedure AlphaBitmapAssign(source: TGraphic);

   property Image:            TGLDBmp read FImgIn write SetImage;
   property AlphaBitmap:      TGLDBmp read FABmpIn write SetABmp;
   property GrayScale:        boolean read FGrayScale write FGrayScale;
   property AlphaChannel:     boolean read FAlphaFlag write FAlphaFlag;

   property CompressLevel:    integer read FCompressLevel write FCompressLevel;
   property FilterType:       TGLDPNGFilterType read FFilterType write FFilterType;
   property IDATSize:         integer read FIDATSize write SetIDATSize;
   property InterlaceType:    TGLDPNGInterlaceType read FInterlaceType write FInterlaceType;
   property ShiftRGB:         integer read FShiftRGB write FShiftRGB;

   property BGColor:          COLORREF read FBGColor write FBGColor;
   property TransColor:       COLORREF read FTransColor write SetTransColor;
   property Text:             string read FText write FText;
   property Gamma:            double read FGamma write FGamma;
   property UnitSpecifier:    TGLDPNGUnitSpecifier read FUnitSpecifier write FUnitSpecifier;
   property WidthSpecific:    integer read FWidthSpecific write FWidthSpecific;
   property HeightSpecific:   integer read FHeightSpecific write FHeightSpecific;
   property NowTime:          boolean read FNowTime write FNowTime;
   property Time:             TPNGTime read GetTime write SetTime;
   property Chromaticities:   TPNGChromaticities read GetChrm write SetChrm;
   property GIFExtension:     TPNGGIFExtension read GetGIFExt write SetGIFExt;

   property OriginalBitCount: integer read FOrgBitCount;
   property MacBinary:        boolean read FMacBinaryFlag write FMacBinaryFlag;
   property Read16Bit:        boolean read FRead16BitFlag write FRead16BitFlag;
   property Password:         string read FPassword write FPassword;

   property OnPassword:       TGLDPNGPasswordEvent read FOnPassword write FOnPassword;
   property OnEncode:         TGLDPNGDECodeEvent read FOnEncode write FOnEncode;
   property OnDecode:         TGLDPNGDECodeEvent read FOnDecode write FOnDecode;
 end;

implementation


//***************************************************
//*   TGLDPNG                                       *
//***************************************************


//------- Create => NX쐬


constructor TGLDPNG.Create;
begin
 inherited;
 FIDATSize:=32768;
 FCompressLevel:=gplDefault;
 FFilterType:=gpfNone;
 FGamma:=0.45455;
 FBGColor:=GLD_NONECOLOR;
 FTransColor:=GLD_NONECOLOR;
 FMacBinaryFlag:=TRUE;
 FNowTime:=TRUE;
 FTime:=SystemPNGTime;
 FImg:=TGLDBmp.Create;
 FABmp:=TGLDBmp.Create;
end;


//------- Destroy => NXJ


destructor TGLDPNG.Destroy;
begin
 if FABmp<>nil then FABmp.Free;
 if FImg<>nil then FImg.Free;
 inherited;
end;


//------- SetIDATSize => IDATTCYݒ


procedure TGLDPNG.SetIDATSize(n: integer);
begin
 if (n<256) or (n>100000) then
  raise EGLDPNG.Create('PNG Param: Err IDAT Size(min:256  max:100000)');
 FIDATSize:=n;
end;


//------- SaveToStream => PNG


procedure TGLDPNG.SaveToStream(Stream: TStream);
var
{$IFNDEF GLD_READONLY}
 pngstream: TGLDPNGWriteStream;
 oldevt: TProgressEvent;
{$ENDIF}
 img: TGLDBmp;

begin
 img:=GetImage;
{$IFNDEF GLD_READONLY}
 pngstream:=TGLDPNGWriteStream.Create;
 try
  // p[^ݒ
  pngstream.CompressLevel :=integer(FCompressLevel);
  pngstream.FilterType    :=integer(FFilterType);
  pngstream.IDATSize      :=FIDATSize;
  pngstream.InterlaceType :=integer(FInterlaceType);
  pngstream.GrayScale     :=FGrayScale;
  pngstream.Text          :=FText;
  pngstream.BGColor       :=FBGColor;
  pngstream.TransColor    :=FTransColor;
  pngstream.Gamma         :=FGamma;
  pngstream.ShiftRGB      :=FShiftRGB;
  pngstream.UnitSpecifier :=integer(FUnitSpecifier);
  pngstream.WidthSpecific :=FWidthSpecific;
  pngstream.HeightSpecific:= FHeightSpecific;
  pngstream.NowTime       :=FNowTime;
  pngstream.Time          :=@FTime;
  pngstream.Chromaticities:=@FChrm;
  pngstream.GIFExtension  :=@FGIFExt;

  pngstream.OnEncode      :=FOnEncode;
  pngstream.Password      :=FPassword;
  if AlphaChannel then
   pngstream.AlphaBitmap:=GetAlphaBitmap;
  // Z[u
  oldevt:=img.OnProgress;
  if Assigned(OnProgress) then img.OnProgress:=OnProgress;
  pngstream.SaveToStream(img,stream);
  img.OnProgress:=oldevt;
 finally
  pngstream.Free;
 end;
 {$ELSE}
 Img.SaveToStream(Stream);
 {$ENDIF}
end;


//------- LoadFromStream => PNGœǂݍ


procedure TGLDPNG.LoadFromStream(Stream: TStream);
var
 pngstream: TGLDPNGReadStream;
 img: TGLDBmp;
 oldevt: TProgressEvent;

begin
 pngstream:=TGLDPNGReadStream.Create;
 img:=GetImage;
 try
  // p[^
  pngstream.OnDecode      :=FOnDecode;
  pngstream.OnPassword    :=FOnPassword;
  pngstream.Password      :=FPassword;
  pngstream.MacBinaryCheck:=FMacBinaryFlag;
  pngstream.Read16Bit     :=FRead16BitFlag;
  pngstream.Time          :=@FTime;
  pngstream.Chromaticities:=@FChrm;
  pngstream.GIFExtension  :=@FGIFExt;
  // At@`lrbg}bvNA
  if FABmp<>nil then FABmp.Assign(nil);
  // [h
  pngstream.AlphaBitmap:=GetAlphaBitmap;

  oldevt:=img.OnProgress;
  if Assigned(OnProgress) then img.OnProgress:=OnProgress;
  pngstream.LoadFromStream(img,stream,0);
  img.OnProgress:=oldevt;

  // [hf[^
  FAlphaFlag     :=pngstream.AlphaChannel;
  FText          :=pngstream.TextData;
  FBGColor       :=pngstream.BGColor;
  FTransColor    :=pngstream.TransColor;
  FInterlaceType :=TGLDPNGInterlaceType(pngstream.InterlaceType);
  FGamma         :=pngstream.Gamma;
  FUnitSpecifier :=TGLDPNGUnitSpecifier(pngstream.UnitSpecifier);
  FWidthSpecific :=pngstream.WidthSpecific;
  FHeightSpecific:=pngstream.HeightSpecific;
  FShiftRGB      :=pngstream.ShiftRGB;
  FOrgBitCount   :=pngstream.OriginalBitCount;
  FGrayScale     :=pngstream.GrayScale;

  SetTransFlag(img);
 finally
  pngstream.Free;
 end;
end;


//------- AlphaBitmapAssign => ɂAt@`lɃRs[


procedure TGLDPNG.AlphaBitmapAssign(source: TGraphic);
begin
 // N͉
 FABmpIn:=nil;

 if source is TGLDPNG then
  begin
   // At@`lRs[
   FABmp.Assign(TGLDPNG(source).FABmp);
  end
 else
  FABmp.Assign(Source);
end;


//------- AlphaBitmapAssignTo => ݓɂAt@`lrbg}bvRs[


function TGLDPNG.AlphaBitmapAssignTo(dest: TGraphic): boolean;
begin
 result:=not FABmp.Empty;
 if result and (dest<>nil) then dest.Assign(FABmp);
end;


//------- FreeAlphaBitmap => ݓɂAt@`lrbg}bvNA


procedure TGLDPNG.FreeAlphaBitmap;
begin
 FABmp.Assign(nil);
end;


//------- sǂݍ(IDEp)


procedure TGLDPNG.ReadData(Stream: TStream);
{$IFDEF GLD_READONLY}
begin
 FImg.LoadFromStream(stream);
 Changed(self);
end;
{$ELSE}
var
 png: TGLDPNGReadStream;

begin
 png:=TGLDPNGReadStream.Create;
 try
  png.Time:=@FTime;
  png.Chromaticities:=@FChrm;
  png.GIFExtension:=@FGIFExt;
  // At@`lrbg}bvNA
  FABmpIn:=nil; FImgIn:=nil;
  if FABmp<>nil then FABmp.Assign(nil);
  png.AlphaBitmap:=FABmp;
  // [h
  png.LoadFromStream(FImg,stream,0);
  // [hf[^
  FAlphaFlag     :=png.AlphaChannel;
  FText          :=png.TextData;
  FBGColor       :=png.BGColor;
  FTransColor    :=png.TransColor;
  FGamma         :=png.Gamma;
  FUnitSpecifier :=TGLDPNGUnitSpecifier(png.UnitSpecifier);
  FWidthSpecific :=png.WidthSpecific;
  FHeightSpecific:=png.HeightSpecific;
  FShiftRGB      :=png.ShiftRGB;
  FOrgBitCount   :=png.OriginalBitCount;
  FGrayScale     :=png.GrayScale;

  SetTransFlag(FImg);
 finally
  png.Free;
 end;
 Changed(self);
end;
{$ENDIF}


//------ \[X(IDEp)


procedure TGLDPNG.WriteData(Stream: TStream);
{$IFDEF GLD_READONLY}
begin
 if (not FImg.Empty) then
  begin
   FImg.SaveToStream(stream);
  end;
end;
{$ELSE}
var
 png: TGLDPNGWriteStream;

begin
 if (not FImg.Empty) then
  begin
   png:=TGLDPNGWriteStream.Create;
   try
    // p[^ݒ
    png.GrayScale     :=FGrayScale;
    png.Text          :=FText;
    png.BGColor       :=FBGColor;
    png.TransColor    :=FTransColor;
    png.Gamma         :=FGamma;
    png.ShiftRGB      :=FShiftRGB;
    png.UnitSpecifier :=integer(FUnitSpecifier);
    png.WidthSpecific :=FWidthSpecific;
    png.HeightSpecific:=FHeightSpecific;
    png.Time          :=@FTime;
    png.Chromaticities:=@FChrm;
    png.GIFExtension  :=@FGIFExt;

    if AlphaChannel then
     png.AlphaBitmap:=FABmp;
    // Z[u
    png.SaveToStream(FImg,stream);
   finally
    png.Free;
   end;
  end;
end;
{$ENDIF}


//------- SetTransparent => ߎw


procedure TGLDPNG.SetTransparent(Value: Boolean);
begin
 if not FTransFlag then
  begin
   if GetImage.Transparent<>Value then GetImage.Transparent:=Value;
  end;
 inherited SetTransparent(Value);
end;


//------- SetTransColor => Fݒ


procedure TGLDPNG.SetTransColor(cor: COLORREF);
var
 img: TGLDBmp;

begin
 img:=GetImage;
 FTransColor:=cor;
 if not img.Empty then
  begin
   if cor=GLD_NONECOLOR then
    begin
     Transparent:=FALSE;
    end
   else
    begin
     img.TransparentColor:=cor;
    end;
  end;
end;


//------- Assign => ʃNXf[^Rs[


procedure TGLDPNG.Assign(source: TPersistent);
begin
 // N͉
 FImgIn:=nil;

 if source is TGLDPNG then
  begin
   // rbg}bvɃRs[
   FImg.Assign(TGLDPNG(source).FImg);
   // At@`lRs[
   FABmp.Assign(TGLDPNG(source).FABmp);
   // Rs[
   FImgIn         :=TGLDPNG(source).FImgIn;
   FABmpIn        :=TGLDPNG(source).FABmpIn;
   FCompressLevel :=TGLDPNG(source).FCompressLevel;
   FFilterType    :=TGLDPNG(source).FFilterType;
   FIDATSize      :=TGLDPNG(source).FIDATSize;
   FInterlaceType :=TGLDPNG(source).FInterlaceType;
   FGrayScale     :=TGLDPNG(source).FGrayScale;
   FText          :=TGLDPNG(source).FText;
   FBGColor       :=TGLDPNG(source).FBGColor;
   FTransColor    :=TGLDPNG(source).FTransColor;
   FGamma         :=TGLDPNG(source).FGamma;
   FShiftRGB      :=TGLDPNG(source).FShiftRGB;
   FUnitSpecifier :=TGLDPNG(source).FUnitSpecifier;
   FWidthSpecific :=TGLDPNG(source).FWidthSpecific;
   FHeightSpecific:=TGLDPNG(source).FHeightSpecific;
   FNowTime       :=TGLDPNG(source).FNowTime;
   FTime          :=TGLDPNG(source).FTime;
   FChrm          :=TGLDPNG(source).FChrm;
  end
 else
  if Source is TGraphic then
   begin
    FImg.Assign(Source);
   end
  else
   begin
    inherited Assign(Source);
    Exit;
   end;

 SetTransFlag(FImg);
end;


//------- AssignTo => ʃNXɃRs[


procedure TGLDPNG.AssignTo(dest: TPersistent);
begin
 if dest is TGraphic then
  dest.Assign(GetImage)
 else
  inherited AssignTo(dest);
end;


//------- LoadFromClipboardFormat => Nbv{[hǂݍ


procedure TGLDPNG.LoadFromClipboardFormat(AFormat: Word;
                                          AData: THandle;
                                          APalette: HPALETTE);
begin
 // rbg}bvɓǂݍ
 // ̏ꍇAN͉
 FImgIn:=nil;
 FImg.LoadFromClipboardFormat(AFormat,AData,APalette);
 SetTransFlag(FImg);
end;


//------- SaveToClipBoardFormat => Nbv{[hɏ


procedure TGLDPNG.SaveToClipboardFormat(var Format: Word;
                                        var Data: THandle;
                                        var APalette: HPALETTE);
begin
 GetImage.SaveToClipboardFormat(Format,Data,APalette);
end;


//------- Draw => \


procedure TGLDPNG.Draw(ACanvas: TCanvas; const Rect: TRect);
begin
 ACanvas.StretchDraw(Rect,GetImage);
end;


//------- GetEmpty => C[W̗LԂ


function  TGLDPNG.GetEmpty: boolean;
begin
 result:=GetImage.Empty;
end;


//------- GetPalette => pbgԂ


function  TGLDPNG.GetPalette: HPALETTE;
begin
 result:=GetImage.Palette;
end;


//------- SetPalette => pbgw


procedure TGLDPNG.SetPalette(hpal: HPALETTE);
begin
 GetImage.Palette:=hpal;
 Changed(self);
end;


//------- GetHeight => Ԃ


function  TGLDPNG.GetHeight: integer;
begin
 result:=GetImage.Height
end;


//------- SetWidth => Ԃ


function  TGLDPNG.GetWidth: integer;
begin
 result:=GetImage.Width;
end;


//------- SetWidth => w


procedure TGLDPNG.SetWidth(n: integer);
var
 img: TGLDBmp;

begin
 img:=GetImage;
 if not img.Empty then img.Width:=n;
 // At@`lύX
 img:=GetAlphaBitmap;
 if not img.Empty then img.Width:=n;
 Changed(self);
end;


//------- SetHeight => w


procedure TGLDPNG.SetHeight(n: integer);
var
 img: TGLDBmp;

begin
 img:=GetImage;
 if not img.Empty then img.Height:=n;
 // At@`lύX
 img:=GetAlphaBitmap;
 if not img.Empty then img.Height:=n;
 Changed(self);
end;


//------- GetAlphaBitmap => ǂݏAt@`lrbg}bvԂ


function TGLDPNG.GetAlphaBitmap: TGLDBmp;
begin
 if FABmpIn=nil then result:=FABmp else result:=FABmpIn;
end;


//------- SetABmp => At@`lrbg}bvN


procedure TGLDPNG.SetABmp(obj: TGLDBmp);
begin
 if (obj<>FImgIn) and (obj<>nil) then FABmpIn:=obj else FABmpIn:=nil;
end;


//------- GetImage => ǂݏΏۃC[WԂ


function TGLDPNG.GetImage: TGLDBmp;
begin
 if FImgIn=nil then result:=FImg else result:=FImgIn;
end;


//------- SetImage => C[WN


procedure TGLDPNG.SetImage(obj: TGLDBmp);
begin
 // At@`l̃NƓ̂Ȃ
 // At@`l̃̕N؂
 if (obj=FABmpIn) and (obj<>nil) then FABmpIn:=nil;
 FImgIn:=obj;
 if obj=nil then obj:=FImg;
 SetTransFlag(obj);
end;


//------- SetTransFlag => C[WύXɔ߂ȂǂύX


procedure TGLDPNG.SetTransFlag(obj: TGraphic);
begin
 PaletteModified:=TRUE;
 if Transparent<>obj.Transparent then
  begin
   FTransFlag:=TRUE;
   try
    Transparent:=obj.Transparent;
   finally
    FTransFlag:=FALSE;
   end;
  end
 else
  Changed(self);
end;


//------- SetGIFExt => GIFf[^ݒ


procedure TGLDPNG.SetGIFExt(gif: TPNGGIFExtension);
begin
 FGifExt:=gif;
end;


//------- GetGifExt => GIFf[^Ԃ


function TGLDPNG.GetGIFExt: TPNGGIFExtension;
begin
 result:=FGIFExt;
end;


//------- SetChrm => Fxݒ


procedure TGLDPNG.SetChrm(cm: TPNGChromaticities);
begin
 FChrm:=cm;
end;


//------- GetChrm => FxԂ


function TGLDPNG.GetChrm: TPNGChromaticities;
begin
 result:=FChrm;
end;


//------- SetTime => Ԑݒ


procedure TGLDPNG.SetTime(tm: TPNGTime);
begin
 FTime:=tm;
end;


//------- GetTime => ԓǂݍ


function  TGLDPNG.GetTime: TPNGTime;
begin
 result:=FTime;
end;


initialization

 TPicture.RegisterFileFormat('PNG','PNG Format',TGLDPNG);

finalization

 {$IFNDEF DEL2}
 TPicture.UnRegisterGraphicClass(TGLDPNG);
 {$ENDIF}

end.
