unit GLDStream;

// ******************************************
// *  GLDGraphicStream                      *
// *                                        *
// *      2002.01.02  Copyright by Tarquin  *
// *                                        *
// ******************************************
//
// ́ATBitmappXg[ANZXNXłB
// Xbhɂ͔ΉłB
//
// ()
//
//  TGLDCustomReadStream
//   EReadStreamoverride邱
//
//  TGLDCustomWriteStream


{$I taki.inc}

interface

uses
 Windows, Classes, SysUtils, Graphics,
 SFunc;

const
 // 𑜓x̒P
 GLD_US_ASPECT = 0;
 GLD_US_METER  = 1;
 GLD_US_INCH   = 2;

type
 TGLDBmp = Graphics.TBitmap;

 // ėp[hJX^NX
 TGLDCustomReadStream=class(TObject)
  private
   FStartCount:          integer;       // R[obNpf[^
   FOldCount:            integer;
   FStdParcent:          integer;
   FMaxParcent:          integer;
   FMaxSize:             integer;
   FCallType:            integer;
   FStartPosition:       integer;
   FOldLineCount:        integer;

   FStreamSize:          integer;       // Xg[̑Ŝ̃TCY
   FReadPos:             integer;       // ݂̈ʒu
   FBuf,FReadBuf:        pbyte;         // obt@|C^
   FBufLength:           integer;       // obt@̃f[^
   FFilePosition:        integer;       // ŏɓǂݍވʒu

   FCancelFlag:          boolean;       // LZ
   FEOFFlag:             boolean;       // t@CI[H(TRUE=I[j

   FMacBinaryFlag:       boolean;       // }bNoCi`FbN̗L
   FMacBinary:           boolean;       // }bNoCi̗L

   FStream:              TStream;       // ǂݍݐ

   function  ReadBuf(zure: integer): boolean;
  protected
   procedure ReadSkipByte(n: integer);
   procedure ReadByte(pp: pointer; len: integer);
   function  Read1Byte: Byte;
   function  ReadWord: Word;
   function  ReadMWord: Word;
   function  ReadDWord: DWORD;
   function  ReadMDword: DWORD;

   procedure SetCallBackParam(ctype,msize,par: integer);
   procedure StartCallBack;
   procedure EndCallBack;
   procedure DoCallBack(cnt: integer);
   function  CallBackProc(cnt: integer): boolean; virtual;

   procedure SetLoadStream(stream: TStream; size: integer);
   procedure FlushStream;

   property Position: integer read FReadPos;
   property EOFFlag: boolean read FEOFFlag;
   property CancelFlag: boolean read FCancelFlag;
   property Stream: TStream read FStream;
  public
   destructor  Destroy; override;
   property MacBinary: boolean read FMacBinary write FMacBinary;
   property MacBinaryCheck: boolean read FMacBinaryFlag write FMacBinaryFlag;
 end;

 // 摜tH[}bgp[hJX^NX
 TGLDCustomGraphicReadStream=class(TGLDCustomReadStream)
  private
   FText:                string;        // eLXgf[^
   FImgWidth,FImgHeight: integer;       // C[W̑傫
   FImgBitCount:         integer;       // C[W̃rbgiDIBpɏCρj
   FOrgBitCount:         integer;       // C[W̃IWirbg
   FPaletteSize:         integer;       // pbg̐F
   FUnitSpecifier:       integer;
   FWidthSpecific:       integer;
   FHeightSpecific:      integer;

   FImage:               TGLDBmp;       // VC[WNX
   FColorBufPtr:         PGLDPalRGB;    // J[e[uۊǗpobt@
   FMes:                 string;        // \bZ[W
   FInfoOnly:            boolean;       // true=̂

   function  CreateColorBuf: PGLDPalRGB;
   procedure FreeColorBuf;
  protected
   procedure ReadStream; virtual; abstract;
   procedure CreateDIB; virtual;
   function  CallBackProc(cnt: integer): boolean; override;

   property Image: TGLDBmp read FImage;
   property InfoOnly: boolean read FInfoOnly;
   property ColorTBLBuf: PGLDPalRGB read CreateColorBuf;
   property Mes: string read FMes write FMes;
  public
   constructor Create; virtual;
   destructor  Destroy; override;
   procedure LoadFromStream(img: TGLDBmp; stream: TStream; size: integer);

   // ǂݍ݉摜
   property Width: integer read FImgWidth write FImgWidth;
   property Height: integer read FImgHeight write FImgHeight;
   property BitCount: integer read FImgBitcount write FImgBitCount;
   property OriginalBitCount: integer read FOrgBitCount write FOrgBitCount;
   property PaletteSize: integer read FPaletteSize write FPaletteSize;
   property UnitSpecifier: integer read FUnitSpecifier write FUnitSpecifier;
   property WidthSpecific: integer read FWidthSpecific write FWidthSpecific;
   property HeightSpecific: integer read FHeightSpecific write FHeightSpecific;

   property TextData: string read FText write FText;
 end;

 // ėpCgJX^NX
 TGLDCustomWriteStream=class(TObject)
  private
   FStartCount:         integer;       // R[obNpf[^
   FOldCount:           integer;
   FStdParcent:         integer;
   FMaxParcent:         integer;
   FMaxSize:            integer;
   FCallType:           integer;
   FStartPosition:      integer;

   FWriteLength:        integer;       // obt@ɏ񂾃f[^
   FWriteStreamSize:    integer;       // Xg[ɏ񂾃f[^
   FWriteBuf,FBuf:      pbyte;         // obt@|C^

   FStream:             TStream;       // ݐ

   FCancelFlag:         boolean;       // LZ
   FMes:                string;        // \bZ[W
   procedure WriteBuf;
  protected
   procedure WriteByte(buf: pointer; cnt: integer);
   procedure Write1Byte(i: integer);
   procedure WriteWord(i: integer);
   procedure WriteMWord(i: integer);
   procedure WriteDWord(i: integer);
   procedure WriteMDWord(i: integer);
   procedure FlushStream;

   procedure SetCallBackParam(ctype,msize,par: integer);
   procedure StartCallBack;
   procedure EndCallBack;
   procedure DoCallBack(cnt: integer);
   function  CallBackProc(cnt: integer): boolean; virtual;

   procedure SetWriteStream(stream: TStream);

   property CancelFlag: boolean read FCancelFlag;
   property Stream: TStream read FStream;
  public
   constructor Create; virtual;
   destructor  Destroy; override;
 end;

 // 摜tH[}bgpCgJX^NX
 TGLDCustomGraphicWriteStream=class(TGLDCustomWriteStream)
  private
   FImage:              TGLDBmp;       // ۑC[W
  protected
   procedure WriteStream; virtual; abstract;
   function  CallBackProc(cnt: integer): boolean; override;

   property Mes: string read FMes write FMes;
   property Image: TGLDBmp read FImage;
  public
   procedure SaveToStream(img: TGLDBmp; stream: TStream);
 end;

function  GLDBitCount(pf: TPixelFormat): integer;
function  GLDPixelFormat(bcnt: integer): TPIxelFormat;

implementation

const
 MaxBufLength         = 65536; // obt@̑傫


//------- GLDPixelFormat => rbgJEgTPixelFormatŕԂ


function GLDPixelFormat(bcnt: integer): TPIxelFormat;
begin
 case bcnt of
   1: result:=pf1bit;
   4: result:=pf4bit;
   8: result:=pf8bit;
  15: result:=pf15bit; 
  16: result:=pf16bit;
  32: result:=pf32bit;
 else
  result:=pf24bit;
 end;
end;


//------- GLDBitCount => TPixelFormatrbgJEgŕԂ


function GLDBitCount(pf: TPixelFormat): integer;
begin
 case pf of
    pf1bit: result:=1;
    pf4bit: result:=4;
    pf8bit: result:=8;
   pf15bit: result:=15;
   pf16bit: result:=16;
   pf32bit: result:=32;
  pfCustom: result:=15;
 else
  result:=24;
 end;
end;


//***************************************************
//*   TGLDCustomGraphicReadStream                   *
//***************************************************


//------- Create => NX쐬


constructor TGLDCustomGraphicReadStream.Create;
begin
 inherited;
 FMacBinaryFlag:=TRUE;
 FText:='';
end;


//------- Destroy => NX


destructor TGLDCustomGraphicReadStream.Destroy;
begin
 FreeColorBuf;
 inherited Destroy;
end;


//------- CreateDIB => cha쐬


procedure TGLDCustomGraphicReadStream.CreateDIB;
var
 i: integer;
 pcor: PDWORD;
 bmp: TBitmap;

begin
 if (not FInfoOnly) then
  with FImage do
  begin
   Assign(nil);
   Transparent:=FALSE;
   PixelFormat:=GLDPixelFormat(FImgBitCount);
   Width:=FImgWidth; Height:=FImgHeight;
   if FColorBufPtr<>nil then
    Palette:=CreatePaletteHandle(ColorTBLBuf,FPaletteSize);
  end;
end;


//------- CreateColorBuf => J[e[upobt@쐬


function TGLDCustomGraphicReadStream.CreateColorBuf: PGLDPalRGB;
begin
 if FColorBufPtr=nil then GetMem(FColorBufPtr,256*sizeof(TGLDPalRGB));
 result:=FColorBufPtr;
end;


//------- FreeColorBuf => J[e[upobt@


procedure TGLDCustomGraphicReadStream.FreeColorBuf;
begin
 if FColorBufPtr<>nil then
  begin
   FreeMem(FColorBufPtr);
   FColorBufPtr:=nil;
  end;
end;


//------- LoadFromStream => Xg[ǂݍ
// () img̃NX͌ĂяoOɍĂƁII
//        size̓[hłőoCgłB
//        At@CȂǂ̓ʂȏꍇ
//        ʏ0iXg[̍őlɂȂjł܂܂B


procedure TGLDCustomGraphicReadStream.LoadFromStream(img: TGLDBmp; stream: TStream; size: integer);
var
 ivn: TNotifyEvent;

begin
 // dCxgj~邽
 FImage:=img;
 FInfoOnly:=(img=nil);
 if (img<>nil) then
  begin
   ivn:=img.OnChange;
   img.OnChange:=nil;
  end;
 try
  // f[^
  SetLoadStream(stream,size);
  FImage:=img;
  FText:='';
  FPaletteSize:=0;
  FUnitSpecifier:=0;
  FWidthSpecific:=0;
  FHeightSpecific:=0;

  // ǂݍ݃C
  ReadStream;
 finally
  // 
  FlushStream;
  FreeColorBuf;
  // Cxg߂
  if (img<>nil) then img.OnChange:=ivn;
 end;
end;


//------- CallBackProc => R[obN{


function TGLDCustomGraphicReadStream.CallBackProc(cnt: integer): boolean;
var
 n: integer;
 md: TProgressStage;
 flg: boolean;

begin
 result:=FALSE;

 if (not FInfoOnly) and Assigned(FImage.OnProgress) then
  begin
   case cnt of
    0:     md:=psStarting;
    1..99: md:=psRunning;
   else
    begin
     md:=psEnding;
     cnt:=100;
    end;
   end;
   FImage.OnProgress(FImage,md,cnt,FALSE,Rect(0,0,0,0),FMes);
  end;
end;


//***************************************************
//*   TGLDCustomReadStream                          *
//***************************************************


//------- Destroy => NX


destructor TGLDCustomReadStream.Destroy;
begin
 if FReadBuf<>nil then
  begin
   FreeMem(FReadBuf);
   FReadBuf:=nil;
  end;
 inherited Destroy;
end;


//------- SetLoadStream => ǂݍݑΏۂ̃Xg[ݒ
// ()
//        size̓[hłőoCgłB
//        At@CȂǂ̓ʂȏꍇ
//        ʏ0iXg[̍őlɂȂjł܂܂B


procedure TGLDCustomReadStream.SetLoadStream(stream: TStream; size: integer);
begin
 // f[^
 FStream:=stream;
 FFilePosition:=stream.Position;
 if size>0 then
  FStreamSize:=size
 else
  FStreamSize:=stream.Size-FFilePosition;
 FReadPos:=0;
 FCancelFlag:=FALSE;
 FEOFFlag:=FALSE;

 // TCY0Ȃ牽Ȃ
 if FStreamSize<=0 then
  begin
   FEOFFlag:=TRUE;
   Exit;
  end;
 if (stream is TMemoryStream) then
  begin
   FBuf:=(stream as TMemoryStream).Memory;
   Inc(FBuf,FFilePosition);
   FBufLength:=FStreamSize;
  end
 else
  begin
   if FReadBuf=nil then GetMem(FReadBuf,MaxBufLength);
   FBufLength:=0;
   FBuf:=FReadBuf;
  end;

 // }bNoCi`FbN
 if FBufLength=0 then ReadBuf(0);
 if FMacBinaryFlag and (FStreamSize>128) then
  begin
   if (PArrayByte(FBuf)^[0]=0) and (PArrayByte(FBuf)^[74]=0) then
    begin
     MacBinary:=TRUE;
     Inc(FBuf,128);
     FReadPos:=128;
    end
   else
    begin
     MacBinary:=FALSE;
     FReadPos:=0;
    end;
  end;
end;


//------- FlushStream => Xg[I


procedure TGLDCustomReadStream.FlushStream;
begin
 if FReadBuf<>nil then
  begin
   FreeMem(FReadBuf);
   FReadBuf:=nil;
  end;
 // ǂ񂾕i߂
 // obt@߂ƂĂ̂Őmȃ[hȂ̂
 //   ̂悤ɂĂ܂B
 if FStream<>nil then FStream.Seek(FReadPos+FFilePosition,soFromBeginning);
end;


//------- SetCallBackParam => R[obN[hݒ
// ctype=R[obN^Cv(0=t@Cǂݍ݈ʒu 1=JEg)
// msize=ctype=0̎̍őJEg
// par=c%犄^%(0=ő 1-100(%))
// ̊֐ĂяoƃR[obNJEg̓NA

procedure TGLDCustomReadStream.SetCallBackParam(ctype,msize,par: integer);
begin
 // Of[^NA
 Inc(FStartCount,FStdParcent);
 FOldCount:=FStartCount;
 Dec(FMaxParcent,FStdParcent);
 // Vf[^ݒ
 if ctype=0 then
  begin
   FMaxSize:=FStreamSize;
   FStartPosition:=FReadPos;
  end
 else
  FMaxSize:=msize;
 if FMaxSize=0 then FMaxSize:=1;
 FCallType:=ctype;
 if (par=0) or (par>=100) then FStdParcent:=FMaxParcent
 else FStdParcent:=(FMaxParcent*par) div 100;
end;


//------- StartCallBack => X^[gR[obN


procedure TGLDCustomReadStream.StartCallBack;
begin
 FStartCount:=0;
 FOldCount:=0;
 FStdParcent:=0;
 FMaxParcent:=99;
 FCancelFlag:=FALSE;

 FCancelFlag:=CallBackProc(0);
end;


//------- EndCallBack => GhR[obN


procedure TGLDCustomReadStream.EndCallBack;
begin
 FCancelFlag:=CallBackProc(100);
end;


//------- DoCallback => R[obN


procedure TGLDCustomReadStream.DoCallBack(cnt: integer);
var
 i,j,k: integer;

begin
 j:=FStdParcent;
 k:=FMaxSize;
 case FCallType of
  0: // t@CTCYJEg
     begin
      i:=((FReadPos-FStartPosition)*j) div k;
     end;
  1: // wJEg
     begin
      if cnt>=k then i:=j else i:=(cnt*j) div k;
     end;
 end;
 Inc(i,FStartCount);
 if (i>FOldCount) then
  begin
   FOldCount:=i;
   if FCallType=1 then
    begin
     FOldLineCount:=cnt;
    end;
   FCancelFlag:=CallBackProc(i);
  end;
end;


//------- CallBackProc => R[obN{


function TGLDCustomReadStream.CallBackProc(cnt: integer): boolean;
begin
 result:=FALSE;
end;


//------- ReadBuf => obt@ɓǂݍ


function TGLDCustomReadStream.ReadBuf(zure: integer): boolean;
var
 i,nn: integer;
 pp: pbyte;

begin
 result:=FALSE;
 // obt@ɓǂݍރoCgvZ
 i:=FStreamSize-FReadPos;
 if i>MaxBufLength-zure then
  begin
   i:=MaxBufLength-zure;
   FBufLength:=MaxBufLength;
  end
 else
  FBufLength:=i+zure;
 // 炷
 pp:=FReadBuf;
 Inc(pp,zure);
 // ǂݍ
 FStream.ReadBuffer(pp^,i);
 // obt@|C^
 FBuf:=FReadBuf;
 result:=TRUE;
end;


//------- ReadSkipByte => ǂݔ΂


procedure TGLDCustomReadStream.ReadSkipByte(n: integer);
begin
 // ǂݍ߂H
 if FEOFFlag or FCancelFlag then Exit;
 if n+FReadPos>FStreamSize then
  begin
   FEOFFlag:=TRUE;
   Exit;
  end;
 // OȂG[
 if n=0 then
  begin
   FCancelFlag:=TRUE;
   Exit;
  end;

 if n<=FBufLength then
  // obt@ő
  begin
   Inc(FBuf,n);
   Inc(FReadPos,n);
   Dec(FBufLength,n);
  end
 else
  // obt@őȂ
  begin
   Inc(FReadPos,n);
   Dec(n,FBufLength);
   FBufLength:=0;
   // t@C̕Ƃ΂
   FStream.Seek(n,soFromCurrent);
  end;
end;


//------- ReadByte => ǂݍ


procedure TGLDCustomReadStream.ReadByte(pp: pointer; len: integer);
var
 n: integer;

begin
 if FEOFFlag or FCancelFlag then Exit;
 // OȂ璆~
 if len<=0 then
  begin
   FCancelFlag:=TRUE;
   Exit;
  end;
 // f[^ꍇ̓G[
 if FStreamSize<FReadPos+len then
  begin
   FEOFFlag:=TRUE;
   Exit;
  end;

 if len<=FBufLength then
  // obt@ő
  begin
   Move(FBuf^,pp^,len);
   Inc(FBuf,len);
   Inc(FReadPos,len);
   Dec(FBufLength,len);
  end
 else
  // obt@őȂ
  begin
   // obt@cf[^ǂݍ
   if FBufLength>0 then
    begin
     Move(FBuf^,pp^,FBufLength);
     Inc(pbyte(pp),FBufLength);
     Dec(len,FBufLength);
     Inc(FReadPos,FBufLength);
     FBufLength:=0;
    end;
   // Xg[ǂݏo
   if len>=MaxBufLength then
    begin
     n:=len-MaxBufLength;
     FStream.ReadBuffer(pp^,n);
     Dec(len,n);
     Inc(pbyte(pp),n);
     Inc(FReadPos,n);
    end;
   // őobt@ȉɂȂobt@ɓǂݍł炾
   if len>0 then
    begin
     ReadBuf(0);
     Move(FBuf^,pp^,len);
     Inc(FBuf,len);
     Inc(FReadPos,len);
     Dec(FBufLength,len);
    end;
  end;
end;


//------- Read1Byte => 1oCgǂݍ


function TGLDCustomReadStream.Read1Byte: byte;
var
 x: longint;

begin
 result:=0;
 // ǂ߂H
 if FEOFFlag or FCancelFlag then Exit;
 if FReadPos+1>FStreamSize then
  begin
   FEOFFlag:=TRUE;
   Exit;
  end;
 // obt@f[^󂫁H
 if FBufLength=0 then ReadBuf(0);
 result:=FBuf^;
 Inc(FReadPos);
 Inc(FBuf);
 Dec(FBufLength);
end;


//------- ReadMWord => 2oCgǂݍ(g[`)


function TGLDCustomReadStream.ReadMWord: Word;
var
 x: longint;

begin
 result:=0;
 // ǂ߂H
 if FEOFFlag or FCancelFlag then Exit;
 if FReadPos+2>FStreamSize then
  begin
   FEOFFlag:=TRUE;
   Exit;
  end;
 // obt@f[^ȂH
 x:=FBufLength;
 if x<2 then
  begin
   if x>0 then Move(FBuf^,FReadBuf^,x);
   ReadBuf(x);
  end;
 x:=PWORD(FBuf)^;
 result:=((x and $FF) shl 8) or ((x and $FF00) shr 8);
 Inc(FReadPos,2);
 Inc(FBuf,2);
 Dec(FBufLength,2);
end;


//------- ReadMDWord => 4oCgǂݍ(g[`)


function TGLDCustomReadStream.ReadMDWord: DWORD;
var
 x: longint;

begin
 result:=0;
 // ǂ߂H
 if FEOFFlag or FCancelFlag then Exit;
 if FReadPos+4>FStreamSize then
  begin
   FEOFFlag:=TRUE;
   Exit;
  end;
 // obt@f[^ȂH
 x:=FBufLength;
 if x<4 then
  begin
   if x>0 then Move(FBuf^,FReadBuf^,x);
   ReadBuf(x);
  end;
 x:=PDWORD(FBuf)^;
 result:=((x and $FF000000) shr 24)+((x and $FF0000) shr 8)+
         ((x and $FF00) shl 8)+((x and $FF) shl 24);
 Inc(FReadPos,4);
 Inc(FBuf,4);
 Dec(FBufLength,4);
end;


//------- ReadWord => 2oCgǂݍ


function TGLDCustomReadStream.ReadWord: Word;
var
 x: longint;

begin
 result:=0;
 // ǂ߂H
 if FEOFFlag or FCancelFlag then Exit;
 if FReadPos+2>FStreamSize then
  begin
   FEOFFlag:=TRUE;
   Exit;
  end;
 // obt@f[^ȂH
 x:=FBufLength;
 if x<2 then
  begin
   if x>0 then Move(FBuf^,FReadBuf^,x);
   ReadBuf(x);
  end;
 result:=PWORD(FBuf)^;
 Inc(FReadPos,2);
 Inc(FBuf,2);
 Dec(FBufLength,2);
end;


//------- ReadDword => 4oCgǂݍ


function TGLDCustomReadStream.ReadDWord: DWORD;
var
 x: longint;

begin
 result:=0;
 // ǂ߂H
 if FEOFFlag or FCancelFlag then Exit;
 if FReadPos+4>FStreamSize then
  begin
   FEOFFlag:=TRUE;
   Exit;
  end;
 // obt@f[^ȂH
 x:=FBufLength;
 if x<4 then
  begin
   if x>0 then Move(FBuf^,FReadBuf^,x);
   ReadBuf(x);
  end;
 result:=PDWORD(FBuf)^;
 Inc(FReadPos,4);
 Inc(FBuf,4);
 Dec(FBufLength,4);
end;


//***************************************************
//*   TGLDCustomGraphicWriteStream                  *
//***************************************************


//------- CallBackProc => R[obN{


function TGLDCustomGraphicWriteStream.CallBackProc(cnt: integer): boolean;
var
 n: integer;
 md: TProgressStage;
 flg: boolean;

begin
 result:=FALSE;
 if Assigned(FImage.OnProgress) then
  begin
   case cnt of
    0:     md:=psStarting;
    1..99: md:=psRunning;
   else
    begin
     md:=psEnding;
     cnt:=100;
    end;
   end;
   FImage.OnProgress(FImage,md,cnt,FALSE,Rect(0,0,0,0),FMes);
  end;
end;


//------- SaveToStream => Xg[ɏ


procedure TGLDCustomGraphicWriteStream.SaveToStream(img: TGLDBmp; stream: TStream);
begin
 // `FbN
 SetWriteStream(stream);
 FImage:=img;
 // 
 WriteStream;
 // 
 FlushStream;
end;


//***************************************************
//*   TGLDCustomWriteStream                         *
//***************************************************


//------- Create => NX쐬


constructor TGLDCustomWriteStream.Create;
begin
 inherited Create;
 GetMem(FWriteBuf,MaxBufLength);
end;


//------- Destroy => NX


destructor TGLDCustomWriteStream.Destroy;
begin
 if FWriteBuf<>nil then FreeMem(FWriteBuf);
 inherited Destroy;
end;


//------- SetWriteStream => Xg[ɏ


procedure TGLDCustomWriteStream.SetWriteStream(stream: TStream);
begin
 // `FbN
 FStream:=stream;
 FBuf:=FWriteBuf;
 FWriteStreamSize:=0;
 FWriteLength:=0;
end;


//------- SetCallBackParam => R[obN[hݒ


procedure TGLDCustomWriteStream.SetCallBackParam(ctype,msize,par: integer);
begin
 // Of[^NA
 Inc(FStartCount,FStdParcent);
 FOldCount:=FStartCount;
 Dec(FMaxParcent,FStdParcent);
 // Vf[^ݒ
 FMaxSize:=msize;
 if FMaxSize=0 then FMaxSize:=1;
 FCallType:=1;  // Writeł0͂ȂI
 if (par=0) or (par>=100) then FStdParcent:=FMaxParcent
 else FStdParcent:=(FMaxParcent*par) div 100;
end;


//------- StartCallBack => X^[gR[obN


procedure TGLDCustomWriteStream.StartCallBack;
var
 rec: TRECT;

begin
 FStartCount:=0;
 FOldCount:=0;
 FStdParcent:=0;
 FMaxParcent:=99;
 FCancelFlag:=FALSE;

 FCancelFlag:=CallBackProc(0);
end;


//------- EndCallBack => GhR[obN


procedure TGLDCustomWriteStream.EndCallBack;
var
 rec: TRECT;

begin
 FCancelFlag:=CallBackProc(100);
end;


//------- DoCallback => R[obN


procedure TGLDCustomWriteStream.DoCallBack(cnt: integer);
var
 i,j,k: integer;
 rec: TRECT;

begin
 j:=FStdParcent;
 k:=FMaxSize;
 case FCallType of
  0: // t@CTCYJEg
     // ̃^CvWriteł͎w֎~
     begin
      //i:=((FStream.Position-FStartPosition)*j) div k;
     end;
  1: // xC
     begin
      i:=(cnt*j) div k;
     end;
 end;
 Inc(i,FStartCount);
 if (i>FOldCount) then
  begin
   FOldCount:=i;
   FCancelFlag:=CallBackProc(i);
  end;
end;


//------- CallBackProc => R[obN{


function TGLDCustomWriteStream.CallBackProc(cnt: integer): boolean;
begin
 result:=FALSE;
end;


//------- FlushStream => Xg[I


procedure TGLDCustomWriteStream.FlushStream;
begin
 if FWriteLength>0 then WriteBuf;
end;


//------- WriteBuf => obt@o


procedure TGLDCustomWriteStream.WriteBuf;
begin
 if FWriteLength=0 then Exit;
 FStream.WriteBuffer(FWriteBuf^,FWriteLength);
 Inc(FWriteStreamSize,FWriteLength);
 FWriteLength:=0;
 FBuf:=FWriteBuf;
end;


//------- WriteByte => oCgPʏ


procedure TGLDCustomWriteStream.WriteByte(buf: pointer; cnt: integer);
begin
 if FCancelFlag then Exit;
 if cnt=0 then
  begin
   FCancelFlag:=TRUE;
   Exit;
  end;

 // obt@傫f[^̏ꍇ͒ɏ
 if (cnt>=(MaxBufLength-16)) then
  begin
   // obt@ɂf[^fo
   WriteBuf;
   // 
   FStream.WriteBuffer(buf^,cnt);
   Inc(FWriteStreamSize,cnt);
  end
 else
  begin
   // obt@̋󂫂Ȃ
   if FWriteLength+cnt>=MaxBufLength then WriteBuf;
   // obt@ɂ
   Move(buf^,FBuf^,cnt);
   Inc(FWriteLength,cnt);
   Inc(FBuf,cnt);
  end;
end;


//------- Wrute1Byte => 1oCg


procedure TGLDCustomWriteStream.Write1Byte(i: integer);
begin
 if FCancelFlag then Exit;
 // obt@̋󂫂Ȃ
 if FWriteLength+1>=MaxBufLength then WriteBuf;
 // obt@ɂ
 FBuf^:=i;
 Inc(FWriteLength);
 Inc(FBuf);
end;


//-------- WriteWord => QoCg


procedure TGLDCustomWriteStream.WriteWord(i: integer);
begin
 if FCancelFlag then Exit;
 // obt@̋󂫂Ȃ
 if FWriteLength+2>=MaxBufLength then WriteBuf;
 // obt@ɂ
 PWORD(FBuf)^:=i;
 Inc(FWriteLength,2);
 Inc(FBuf,2);
end;


//------- WriteMWord => QoCg(g[j


procedure TGLDCustomWriteStream.WriteMWord(i: integer);
begin
 if FCancelFlag then Exit;
 // obt@̋󂫂Ȃ
 if FWriteLength+2>=MaxBufLength then WriteBuf;
 // obt@ɂ
 PWORD(FBuf)^:=((i and $FF) shl 8) or ((i and $FF00) shr 8);
 Inc(FWriteLength,2);
 Inc(FBuf,2);
end;


//------- WriteDWord => SoCg


procedure TGLDCustomWriteStream.WriteDWord(i: integer);
begin
 if FCancelFlag then Exit;
 // obt@̋󂫂Ȃ
 if FWriteLength+4>=MaxBufLength then WriteBuf;
 // obt@ɂ
 PDWORD(FBuf)^:=i;
 Inc(FWriteLength,4);
 Inc(FBuf,4);
end;


//------- WriteMDWord => SoCg(g[j


procedure TGLDCustomWriteStream.WriteMDWord(i: integer);
begin
 if FCancelFlag then Exit;
 // obt@̋󂫂Ȃ
 if FWriteLength+4>=MaxBufLength then WriteBuf;
 // obt@ɂ
 PDWORD(FBuf)^:=((i and $FF) shl 24) or ((i and $FF00) shl 8) or
                ((i and $FF0000) shr 8) or ((i and $FF000000) shr 24);
 Inc(FWriteLength,4);
 Inc(FBuf,4);
end;

end.
